/*******************************************************************************
*	Socket functions. socket.h
*	Last Modified: 1/May/2009
*
*	Copyright (C) 2009 Tony Wu mdzz@u.washington.edu
*
*	This program is free software: you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation, either version 3 of the License, or
*	(at your option) any later version.
*
*	This program is distributed in the hope that it will be useful,
*	but WITHOUT ANY WARRANTY; without even the implied warranty of
*	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*	GNU General Public License for more details.
*
*	You should have received a copy of the GNU General Public License
*	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*******************************************************************************/

#ifndef SOCKET_H
#define SOCKET_H

#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <strings.h>
#include <sys/ioctl.h>
#include <termios.h>
#include <signal.h>
#include <math.h>
#include <stdarg.h>
#include <sys/time.h>
#include <netinet/in.h>
#include "network.h"

#define BUFFER_LEN 512
#define CMD_PORT 8081
#define DATA_PORT 8082
#define UPDATE_INTEVAL 1
#define GUI_IP "192.168.99.100"	// IP address for GUI

// cmd socket between basenode and GUI
void *cmdSocket(unsigned char *cmd_list);
// data socket between basenode and GUI
int dataSocket(packet in_pkt);
// error report socket between basenode and GUI
int errorSocket(packet in_pkt);
// routing packet to be sent back to GUI
int routingSocket(__u16 *routingTable, unsigned char routingTable_size);

#endif
