/*******************************************************************************
*	Utility functions. util.h
*	Last Modified: 27/May/2009
*
*	Copyright (C) 2009 Tony Wu mdzz@u.washington.edu
*
*	This program is free software: you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation, either version 3 of the License, or
*	(at your option) any later version.
*
*	This program is distributed in the hope that it will be useful,
*	but WITHOUT ANY WARRANTY; without even the implied warranty of
*	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*	GNU General Public License for more details.
*
*	You should have received a copy of the GNU General Public License
*	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*******************************************************************************/

#ifndef UTIL_H
#define UTIL_H

#include <stdio.h>
#include <linux/types.h>
#include <pthread.h>

//
#define util_debug 0

/* linked list node for threads */
typedef struct T_node_St
{
	pthread_t e;
	struct T_node_St *next;
} T_Node;

/* helper function sets the current node address according to the config file */
int set_addr();
/* helper function gets the current node address */
__u16 get_addr();
/* helper function this function checks if the current node is the base node */
int check_base();
/* this function initializes the join list */
int init_joinList();
/* this function appends a node to the end of the list */
T_Node *tNode_append(T_Node *h, pthread_t e);
/* this function deletes a node form the join list */
void tNode_delete(T_Node *prev, T_Node *cur);
/* this function returns tNode_Head */
T_Node *return_tNode_head();
/* this function joins the given threads to the main thread */
void join_threads();
#endif
